Description

When committing FHICL file to the DB, 32 bit positive ints with the top bit set high are converted to negative (this is a problem with
array parameters where reading back into a vector of uint in user code fails). This seems to me to be undesirable behaviour.

See, e.g., the file common_code/ssp_standard in the configuration sspEmulator00019, where an element of the parameter
ARR_pdts_cmd_control was set to 0x80000FFF before importing, but is converted by the database to -2147483648. The same
behaviour is observed when the value is written in decimal rather than hex.

Related issues:
Related to artdaq Utilities - Bug #17425: FHiCL numerical parameters truncate... Closed 08/10/2017

History

#1 - 08/08/2017 11:01 AM - Martin Haigh
Clarification: | am talking about a configuration in the DB for the CERN test stand for protoDUNE.

#2 - 08/14/2017 01:10 PM - John Freeman

To reproduce this error, log into pddag-gen05-dag0 from Ixplus.cern.ch as usual, and then do the following:

cd /dag/artdag

source setup_database.sh

tmpdirl=$PWD/$ ( uuidgen )

mkdir S$tmpdirl

cd $tmpdirl

conftool.py exportConfiguration sspEmulator00025

sed -r —-i 's/BEGIN_PROLOG/BEGIN_PROLOG\nissuetest: OxFFFFFFFF/' common_code/ssp_standard.fcl
conftool.py importConfiguration sspEmulator

cd ..

tmpdir2=$PWD/$ ( uuidgen )

mkdir S$tmpdir2

cd $tmpdir2

conftool.py exportConfiguration <name of sspEmulator configuration which was Jjust imported>
@el oo

diff -r $tmpdirl $tmpdir2

#3 - 08/14/2017 02:10 PM - Gennadiy Lukhanin
- Related to Bug #17425: FHICL numerical parameters truncated by DB! added

#4 - 07/30/2018 01:00 PM - Gennadiy Lukhanin

- Status changed from New to Resolved
Fixed in the version v1_04_46 of artdaq_database.

#5 - 10/31/2019 02:17 PM - Gennadiy Lukhanin
- % Done changed from 0 to 100

- Status changed from Resolved to Closed
